<?php

###############################################################################
#                                                                             #
# Library File for pkIRIS-RA                                                  #
#                                                                             #
###############################################################################


################################### FUNCTIONS #################################

#
# function cabecera: anyade al codigo desde el que se invoca la funcion el
# menu con las opciones disponibles. Este menu variara dependiendo del valor
# de '$idCabecera'. Tambien anyade informacion como el titulo de la pagina
# o el logo de la organizacion entre otras cosas. Normalmente se llamara al 
# principio del codigo, mostrando la informacion a modo de cabecera de pagina.
#
function cabecera($idCabecera) {
   global $menu;
   global $pkiris;
   global $organization;
   global $urlVar; 
   global $ldapVar;
   global $raName;

   // Inicializamos la variable de error a cero
   $errorCode = "a0";

   $tabText = "pkIRIS";
   echo "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN'
   'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'>
    <html xmlns='http://www.w3.org/1999/xhtml' xml:lang='es'>
    <head>
       <meta http-equiv='content-type' content='text/html;charset=utf-8' />
       <link rel='shortcut icon' href='../images/favicon.ico' />
       <title>CICA | Infraestructura de Clave P&uacute;blica</title>
       <style type='text/css' media='all'>@import '/styles/pkiris.css';</style>
    </head>\n";

   echo "<body#pkiris>
   <div id='container'>
      <div id='pkHeader'>
         <img alt='logo' src='/images/pkiris-sample-logo.png'>
	 <div id='galipollo'>
	    <img alt='galipollo' src='/images/pkiris-galipollo-logo.png'>
	 </div> <!-- galipollo -->
      </div> <!-- pkHeader -->
      <div id='nav'>
         <ul>
         <li><a href='".$organization['homeURL']."' title='".$organization['homeURLtxt']."'>".$organization['name']."</a></li>
         <li><a href='".$pkiris['homeURL']."' title='".$pkiris['homeURLtxt']."'>".$pkiris['name']."</a></li>\n";

      // El valor de $idCabecera nos indicara la seccion donde estemos, y 
      // segun cual sea mostraremos una informacion u otra	      
      switch($idCabecera) {
         case 1: // Seccion de usuarios de la RA
            $tabText = "Usuarios";
            echo "<li><a href='".$urlVar['raPublic']."' title='Usuarios de la RA'>RA: ".$raName."</a></li>";
	    break;
         case 2: // Seccion de administracion de la RA
            $tabText = "Admin RA";
            echo " <li><a href='".$urlVar['raPublic']."' title='Usuarios de la RA'>RA: ".$raName."</a></li>
		<li><a href='".$urlVar['raAdmin']."' title='Administraci&oacute;n de la RA'>Admin</a></li>\n";
            
            // Si el usuario se auntentica por certificado, obtenemos y 
            // mostramos su nombre
            if ( $pkiris['authMethod'] == "plainCc" || $pkiris['authMethod'] == "ldap" ) {
               $dn = getDn();
   	       if ( !$dn )
	          $errorCode = "a1b3c20";
               else {
                  echo "</ul>
                  <div id='nav_user'>\n";
    	          // Buscamos la informacion del usuario para presentar su informacion
	          $filter = "(&(objectClass=pkirisCertificate)(pkirisSubjectDn=$dn)(pkirisStatus=issued))";
	          $justthese = array($ldapVar['rdnAttr']);
	          $result = ldap_get_info($ldapVar['base'], $filter, $justthese);
	          if (!$result)
                     $errorCode = "a1b3c1";
	          else {
	             $eeCopa = $result[0][$ldapVar['rdnAttr']][0];
	             list($eeCopa, $kk) = split("c",$eeCopa);	
                     $filter = "(&(objectClass=pkirisEndEntity)(".$ldapVar['rdnAttr']."=$eeCopa))";
	             $justthese = array("cn", "sn");
	             $result = ldap_get_info($ldapVar['base'], $filter, $justthese);
	             if (!$result)
                        $errorCode = "a1b3c1";
	             else
	                echo "Usuario: ".$result[0]["cn"][0]. " " . $result[0]["sn"][0];	      
	          }
               }	    
               echo "</div>";
            }
	    break;
         case 3: // Seccion de administracion de la pkIRIS
            $tabText = "Admin PKI";
            break;	    
	 case 4: // Seccion de la CA
	    $tabText = "CA"; 
	    break;
         case 5: // Seccion de Operadores de la CA
            $tabText = "Oper CA";
            break;
      }	 

      echo "</div>
      <div id='nav_sombra'></div>
       </ul>
       <div id='pkBody'>
         <div id='sidebar'>";

// ini: Menu de la izq 

      echo "       <div id='tbox'>
       <h3 class='head_a1b1'>$tabText</h3>
        <ul>\n";

   while (list ($index, $content) = each ($menu[$idCabecera])) {
      if ( strncmp($index, "nohref", 6) == 0 )
         echo "&nbsp;&nbsp;$content\n";
      else
         echo "<li><a href='$index'>$content</a></li>\n";
   }

   echo "</ul>
      </div> <!--tbox menu-->\n";
// end: Menu de la izq

   if ( $pkiris['authMethod'] != "none" ){
      echo "<!-- Ini: Login -->
      <div id='tbox'>\n";
      if (!isset($_SESSION['user']) ) {
            echo "
             <h3 class='head_a1b1'>Login</h3>
             <form action='/auth.php' method='post'>
               <div id='tbox_data_a1b1'>
                  Usuario<br/>
                  <input type='text' name='user' size='23' /><br/>
                  Clave<br/>
                  <input type='password' name='passwd' size='23' /><br />
                     <input class='button' type='submit' name='boton1' value='Entrar' />
               </div>
            </div>
	    <!-- End: Login -->
	    </form>\n";
      }
      else {
            echo "
            <h3 class='head_a1b1'>Login</h3>
            <div id='tbox_data_a1b1'>
            Bienvenid@<br/>\n";
            $user=$_SESSION['user'];
            $filter = "(&(objectClass=pkirisEndEntity)(pkirisID=$user))";
            $justthese = array("cn", "sn");
            $result = ldap_get_info($ldapVar['base'], $filter, $justthese);
            if (!$result)
               $errorCode = "a1b3c1";
            else if ( $result['count'] > 0 && $pkiris['authMethod'] == "ldap" ) 
               echo $result[0]["cn"][0]. " " . $result[0]["sn"][0]."<br/>";    
            else
	       echo $user . "<br/>";
            echo "<a class='login' href='/close_session.php'>&nbsp;Cerrar sesi&oacute;n&nbsp;</a><br/>
            </div>\n";
      }
      echo"</div> <!-- tbox login -->\n";
   }
   echo "</div><!--sidebar-->
   <div id='content'>\n";

$pkiLog['status'] = "none";
$pkiLog['eee'] = "none";
$pkiLog['user'] = "none";
$pkiLog['error'] = $errorCode;
pkirisErrorHandler($pkiLog);

}

#
# function pie: anyade informacion al codigo desde el que se invoca a la 
# funcion. Normalmente esta funcion se llamara al final del codigo, a modo de
# pie de pagina.
#
function pie() {
   echo "</div> <!-- content -->
   </div> <!-- pkBody -->

   <div id=\"ie_fix_01\"><!-- Mamoneo IE --></div>

   <div id='pkFooter'>
      <div id='url'>
        <a href='http://www.rediris.es/app/pkiris/'><img 
           border='0' src='/images/pkiris-icon.png'></a>
      </div>
      <div id='credits'>
         pkIRIS 2005-2006
      </div>
   </div> <!-- pkFooter -->
   </div> <!-- container -->
</body>
</html>\n";
				 
}

						     
#
# function incrCounter: increases the pkiriscounter of the user or csr 
# which copa code is $copa.
#
function incrCounter($copa){
   global $ldapVar;

   $errorCode = "a0";
   $retValue = false;
   $filter = ($ldapVar['rdnAttr']."=$copa"); 
   $dn = $ldapVar['rdnAttr']."=$copa,".$ldapVar['base'];
   $justthese = array ("pkiriscounter");

   $userCount = ldap_get_info($dn,$filter,$justthese);
   if (!$userCount)
      $errorCode = "a1b3c1";
   else {
      $incrUsr["pkiriscounter"] = $userCount[0]["pkiriscounter"][0] + 1;
      if ( $userCount['count'] > 0 ) {
         $retValue = ldap_mod_info($dn, $incrUsr);
         if (!$retValue)
            $errorCode = "a1b3c2";
      }
   }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;			       
}

#
# function getCounter: return the pkirisCounter.
#
function getCounter($copa){
   global $ldapVar;   	
   
   $errorCode = "a0";
   $retValue = false;
   $filter = ($ldapVar['rdnAttr']."=$copa");
   $dn = $ldapVar['rdnAttr']."=$copa,".$ldapVar['base'];
   $justthese = array ("pkiriscounter");

   $userCount = ldap_get_info($dn,$filter,$justthese);
   if ( !$userCount )
      $errorCode = "a1b3c1";
   else {
      if ( $userCount['count'] > 0 ) 
         $retValue = $userCount[0]["pkiriscounter"][0];
   }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;	
}


#
# function getMail: return the e-mail address of the user whose copa code is $copa.
#
function getMail($copa){
  global $ldapVar;	
 
  $errorCode = "a0"; 
  $retValue = false;
  list($copaUsr,$c)=split("c",$copa);
  $filter = "(&(objectclass=pkirisEndEntity)(".$ldapVar['rdnAttr']."=$copaUsr))";
  $dn = $ldapVar['rdnAttr']."=$copaUsr,".$ldapVar['base'];
  $justthese = array ("mail");

  $userMail = ldap_get_info($dn,$filter,$justthese);
  if ( !$userMail )
     $errorCode = "a1b3c1";
  else {
     if ( $userMail['count'] > 0 )
        $retValue = $userMail[0]["mail"][0];     
  }
  $pkiLog['status'] = "none";
  $pkiLog['eee'] = "none";
  $pkiLog['user'] = "none";
  $pkiLog['error'] = $errorCode;
  pkirisErrorHandler($pkiLog);
  
  return $retValue;
}

#
# function getNavType: return the navigator type of the CSR which copa code is $copa
#
function getNavType($copa){
   global $ldapVar;
   
   $errorCode = "a0";
   $retValue = false;
   $filter = ($ldapVar['rdnAttr']."=$copa");
   $dn = $ldapVar['rdnAttr']."=$copa,".$ldapVar['base'];   
   $justthese = array ("pkiriscsr");

   $csr = ldap_get_info($dn,$filter,$justthese);
   if ( !$csr ) 
      $errorCode = "a1b3c1";
   else {
      if ( $csr['count'] > 0 ) {
         // comparamos 5 primeros caracteres de la CSR, suficientes para identificar 
         // el tipo de navegador que se utilizo al generar la solicitud
         if ( strncmp($csr[0]["pkiriscsr"][0], "SPKAC", 5) == 0 )
            $retValue = "SPKAC";
         else
            $retValue = "IE";
      }
   }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}

#
# function getBrowser: devuelve el tipo de navegador desde el que se esta 
# realizando la solicitud
#
function getBrowser() {
   $retValue = false;
   $browser_number = '';
   // get userAgent string
   $browser_user_agent = ( isset( $_SERVER['HTTP_USER_AGENT'] ) ) ? strtolower( $_SERVER['HTTP_USER_AGENT'] ) : '';
   //pack browser array
   // values [0]= user agent identifier, lowercase, [1] = dom browser, [2] = shorthand for browser,
   $a_browser_types[] = array('opera', true, 'op' );
   $a_browser_types[] = array('msie', true, 'ie' );
   $a_browser_types[] = array('konqueror', true, 'konq' );
   $a_browser_types[] = array('safari', true, 'saf' );
   $a_browser_types[] = array('gecko', true, 'moz' );

   for ($i = 0; $i < count($a_browser_types); $i++) {
      $s_browser = $a_browser_types[$i][0];
      $b_dom = $a_browser_types[$i][1];
      $retValue = $a_browser_types[$i][2];
      // if the string identifier is found in the string
      if (stristr($browser_user_agent, $s_browser)) {
      // we are in this case actually searching for the 'rv' string, not the gecko string
      // this test will fail on Galeon, since it has no rv number. You can change this to 
      // searching for 'gecko' if you want, that will return the release date of the browser
      if ( $retValue == 'moz' )
         $s_browser = 'rv';
      break;
      }
   }
   return $retValue;
}  

#
# function renewalsCounter: devuelve el numero de certificados renovados que ha
# tenido el usuario con codigo copa indicado por $copa 
#
function renewalsCounter($copa) {
   global $ldapVar;
   global $pkiris;
   global $traceIndices;

   $errorCode = "a0";
   $retValue = false;
   $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa*))";
   $justthese = array ("pkiristrace");
   // Obtenemos todas las trazas de todas las solicitudes del usuario indicado por $copa
   $pkirisTraces = ldap_get_info($ldapVar['base'],$filter,$justthese);
   if ( !$pkirisTraces )
      $errorCode = "a1b3c1";
   else {
      if ( $pkirisTraces['count'] > 0 ) {
         $renewalsNumber = 0;
         $end = false;
  
         // Ordenamos la matriz en orden inverso. Incrementaremos el contador
         // cuando se encuentre una traza a renew, y pararemos de contar cuando
         // encuentre una a new. De este modo obtenemos el numero de renovaciones
         // del usuario desde la ultima vez que hizo una nueva solicitud ('new')
         arsort($pkirisTraces);
         // Recorremos todos las solicitudes
         while (list($index) = each($pkirisTraces) AND !$end) {
            $isIssued = false;  
            $isRenewed = false;       
            if  ($index != "count") { 
               // Para cada solicitud, recorremos todas sus trazas
               while (list(,$trace) = each($pkirisTraces[$index]['pkiristrace'])) {
                  // Parseamos la traza por el prefijo $pkiris['urnPrefix']
                  list($k, $tmp) = split($pkiris['urnPrefix'], $trace);
	          // y metemos en un array el resto de componentes de la traza
	          $tr = split(":", $tmp);
	          // Le quitamos el primer elemento porque no contiene nada
	          array_shift ($tr);
	    
                  // En traceIndices['status'] se encuentra el indice correspondiente al
	          // campo que contiene el estado de la traza (0, 1 ... n)
	          $tmpStatus = $tr[$traceIndices['status']];
	          list($traceStatus, $k) = split (";", $tmpStatus);
	    
	          if ($traceStatus == "issued")
	             $isIssued = true;

   	          if ($traceStatus == "renew")
	             $isRenewed = true; 

	          if ($traceStatus == "new")
	             $end = true;
               }
            }
            // Solo si la solicitud ha sido firmada y renovada en algun momento, 
            // incrementaremos el contador
            if ($isIssued AND $isRenewed)
               $renewalsNumber++;
         }
	 $retValue = $renewalsNumber;
      }
   }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}

# function parseXML: construye y devuelve un array con todos los tags del 
# codigo XML correspondiente al fichero de entrada. Sera un array multivaluado 
# indexado por el numero de solicitud dentro del fichero, seguido del nombre 
# del tag y su valor. La posicion '0' esta reservada para informacion del 
# propio fichero. Si hay algun error, devuelve 'false'.
#
function parseXML ($xmlFile) {
   global $raPrivKey;
   global $pkiris;
   global $traceIndices; 
  
   $errorCode = "a0"; 
   // Creamos un array con las expresiones regulares que parsearemos
   // el fichero XML.
   
   // Expresiones comunes a todos los tipos de XML
   $regex['pki'] = "/<pki type=(.*) version=.*>\n(.*?)\n<\/pki>/ms";
   $regex['header'] = "/<header>(.*?)<\/header>/ms";
   $regex['data'] = "/<data>(.*?)<\/data>/ms";
   $regex['sig'] = "/<sig>(.*?)<\/sig>/";
   $regex['total_sig'] = "/<total_sig>(.*)?<\/total_sig>/";
   
   $regex['dn'] = "/<dn>(.*?)<\/dn>/";
   $regex['id'] = "/<id>(.*?)<\/id>/";
   $regex['copa_id'] = "/<copa_id>(.*?)<\/copa_id>/";
   $regex['traces'] = "/<traces>(.*?)<\/traces>/ms";
   $regex['traceurn']= "/<trace>(urn:mace:rediris.es:.+:.+:csr:state:.+:.+:.+)<\/trace>/";
   
   // Leemos el fichero con las solicitudes y los pasamos a una cadena
   $xmlContent = file_get_contents($xmlFile);
   
   if ( !$xmlContent )
      $errorCode = "a1b3c4";
   else {
         // Obtenemos el tipo de XML y lo guardamos en arrayData
         $r = preg_match($regex['pki'], $xmlContent, $xmlInfo['pki']);
         if ( !$r )
            $errorCode = "a1b3c5";
         else {
            $xmlType = $xmlInfo['pki'][1];
            $arrayData[0]['xmlType'] = $xmlType;
            
            // CRTs y RVKs
            if ( $xmlType == '"crt"' )  {
	       // Expresiones regulares que nos serviran para obtener la informacion
               // de los ficheros que contengan tanto certificados como revocaciones 
	       // de los mismos
	       $regex['requests_type'] = "/(<crt2ra>.*?<\/crt2ra>)/ms";
	       $regex['request_type'] = "/<(crt|rvk|rfd)>(.*?)<\/(crt|rvk|rfd)>/ms"; 
	       $regex['status'] = "/<status>(.*?)<\/status>/";
	       $regex['expiration_date'] = "/<expiration_date>(.*?)<\/expiration_date>/";
	       $regex['date'] = "/<date>(.*?)<\/date>/";
            }
            else  
               $errorCode = "a1b3c6"; //XML no soportado
     						  
            // Como estamos en una RA, tenemos que parsear el fichero con
            // la clave de secreto compartido de la CA y firmar cada 
            // solicitud con su clave correspondiente
            $privKey = $pkiris['secret'];

            if ( $errorCode == "a0" ) {       
               // Nos quedamos con todas las solicitudes del tipo 'requestsType' (lo que 
               // va entre crt2ca> y </crt2ca> en los certificados de vuelta a la RA). 
               preg_match($regex['requests_type'], $xmlContent, $xmlInfo['allRequests']);
    
               // Obtenemos la firma del fichero
               preg_match($regex['total_sig'], $xmlContent, $xmlInfo['total_sig']);
               $arrayData[0]['total_sig'] = $xmlInfo['total_sig'][1];
               // Comprobamos que los xmlContent no han sido modificados firmando con
               // la clave secreta de la RA. Tenemos que anyadirle un salto de linea
               // al bloque de las solicitudes
               $sha1_file_sig = sha1($xmlInfo['allRequests'][1] . "\n" . $privKey);

               if ($xmlInfo['total_sig'][1] == $sha1_file_sig)
               {
                  // Vamos a analizar cada solicitud
                  $csrsNumber = preg_match_all($regex["request_type"], $xmlContent, $xmlInfo['requests']);
                  for ($i = 0; $i < $csrsNumber; $i++) {
	             // Obtenemos el tipo de solicitud y la propia solicitud
   	             $request_type = $xmlInfo['requests'][1][$i];
                     $currentRequest = $xmlInfo['requests'][2][$i];
	  
 	             // La informacion de la primera solicitud empezara en la posicion
	             // 1 del array
	             $index = $i+1; 
	    
  	             // Sacamos la informacion del fichero XML. Datos comunes a
	             // los diferentes tipos de XML
	             $r = preg_match($regex['header'], $currentRequest, $xmlInfo['header']);
	             $r = preg_match($regex['data'], $currentRequest, $xmlInfo['data']);
	             $r = preg_match($regex['sig'], $currentRequest, $xmlInfo['sig']);
   	             $r = preg_match($regex['id'], $xmlInfo['header'][1], $xmlInfo['id']);
                     $r = preg_match($regex['copa_id'], $xmlInfo['header'][1], $xmlInfo['copa_id']); 
	             $r = preg_match($regex['dn'], $xmlInfo['header'][1], $xmlInfo['dn']);
	             $r = preg_match($regex['traces'], $xmlInfo['header'][1], $xmlInfo['traces']);
                     $tracesNumber = preg_match_all($regex['traceurn'], $xmlInfo['traces'][1], $xmlInfo['traceurn']);
            
	             // Y la anyadimos al array de retorno (menos data y sig que se 
	             // anyadiran al final). Dejamos la posicion 0 del array para datos 
	             // comunes a las solicitudes. 
	             for ($j = 0; $j < $tracesNumber; $j++)
                        $arrayData[$index]['traces'][$j] = $xmlInfo['traceurn'][1][$j]; 

                     $arrayData[$index]['id'] = $xmlInfo['id'][1];
                     $arrayData[$index]['copa_id'] = $xmlInfo['copa_id'][1];
	             $arrayData[$index]['dn'] = $xmlInfo['dn'][1];
	             $arrayData[$index]['requesttype'] = $request_type;
	    
	             // Dependiendo si es un tipo u otro de estructura XML, 
	             // obtendremos una informacion adicional direfente
	             // CRTs
	             if ( $xmlType == '"crt"' ) {
	                $r = preg_match($regex['status'], $xmlInfo['header'][1], $xmlInfo['status']);
	                $r = preg_match($regex['date'], $xmlInfo['header'][1], $xmlInfo['date']);
	       
	                if ( $request_type == "crt" ) {
  	                   $r = preg_match($regex['data'], $currentRequest, $xmlInfo['data']);
	                   $r = preg_match($regex['expiration_date'], $xmlInfo['header'][1], $xmlInfo['expiration_date']);
		           $arrayData[$index]['expiration_date'] = $xmlInfo['expiration_date'][1];
	                }	       
	                // Completamos arrayData con la informacion que acabamos de
	                // obtener del XML
	                $arrayData[$index]['status'] = $xmlInfo['status'][1];
	                $arrayData[$index]['date'] = $xmlInfo['date'][1];
	             }   	    
	   
	             // Le anyadimos al array la firma de la solicitud
	             $arrayData[$index]['sig'] = $xmlInfo['sig'][1];
	   
	             // Componemos una cadena con la informacion de la solicitud
                     // para verificar si su suma de control sha1 es correcta
                     $cadena = "<header>".$xmlInfo['header'][1]."</header>\n";
	    
	             // Le anyadimos al array el contenido del tag 'data' (en caso de
                     // que no sea ni un certificado revocado ni uno rechazado). Tambien
	             // hay que añadirselo a la cadena
	             if ( $request_type != "rvk" && $request_type != "rfd" ) {
	                $arrayData[$index]['data'] = $xmlInfo['data'][1];	       
                        $cadena = $cadena . "<data>".$xmlInfo['data'][1]."</data>\n";
  	             }

                     // Cada solicitud se habra firmado con la clave de su RA 
                     // correspondiente, por lo que tenemos que obtenerla y 
                     // comprobar que son correctas las firmas de todas ellas. 
                     // Nos quedamos con el numero de ra ('ai')
                     list ($raCopa, $k) = split ("b", $xmlInfo['copa_id'][1]);
                     $privKey = getRaPrivKey($raCopa);
                     if ( !$privKey ) 
                        $errorCode = "a1b3c10";
                  
                     // Obtenemos la suma sha1 de la cadena + claveRA + pkirisCopaID
                     $sha1_request_sig = sha1($cadena . $privKey . $xmlInfo['copa_id'][1]);
	    
                     if ( $xmlInfo['sig'][1] == $sha1_request_sig ) { 
  	                // Tenemos que comprobar las firmas de todas trazas		 		 
	                $found = false;
                        while ( (list (,$value) = each($arrayData[$index]['traces'])) && !$found) {
                           // Parseamos la traza por el prefijo $pkiris['urnPrefix']
                           list($k, $tmp) = split($pkiris['urnPrefix'], $value);
                           // y metemos en un array el resto de componentes de la traza
		           $tr = split(":", $tmp);
      		           // Le quitamos el primer elemento porque no contiene nada
                           array_shift ($tr);
		  
		           // En traceIndices['sha1'] se encuentra el indice 
		           // correspondiente al campo que contiene la firma de la 
		           // traza ($0, $1 ... $4)
		           $sigIndex = $traceIndices['sha1'];
                           $traceSig = $tr[$sigIndex];
		  
                           // Componemos la cadena a verificar. Usaremos todos los 
                           // componentes de la traza menos la firma sha1
	      	           $g = 0;
		           while( $g < count($tr) ) {
		              // Si no es la firma, insertamos el elemento en el array
		              if ( $g != $sigIndex )
		                 $trAux[$g] = $tr[$g];
		              // Si es el componente con la firma y no es el ultimo 
		              // elemento, insertamos el siguiente en el array
		              else if ( $g != count($tr) -1 ) {  
		                 $trAux[$g] = $tr[$g+1];
			         $g++;
		              }			
		              $g++;
		           }
		  
                           $cadena =  $pkiris['urnPrefix'].":$trAux[0]:$trAux[1]:$trAux[2]:$trAux[3]";
		           // Obtenemos el sha1 de la cadena		 
		           $sha1_trace_sig = sha1($cadena . $privKey . $xmlInfo['copa_id'][1]);
                           if ($traceSig != $sha1_trace_sig) {
                              $found = true;
	                      $errorCode = "a1b3c9";
                           }
                        } //endwhile		    		 
                     }
	             else 
                        $errorCode = "a1b3c8";
                  } //endfor  
               }
               else 
                  $errorCode = "a1b3c7";
            }
         }
   }
   if ($errorCode == "a0")
      $retValue = $arrayData;
   
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}

#
# function createXML: esta funcion crea un fichero con el codigo XML de todas 
# las solicitudes, el cual sirve para transmitir informacion entre la RA y la 
# CA. Recibe un array los codigos copa de las solicitudes o los certificados 
# que van a ser exportados, y devuelve una cadena con el codigo XML si no ha 
# habido ningun error o 'false' en el caso de que si los haya habido. 
#
function createXML ($copasArray) {
   global $ldapVar;
   global $dirVar;
   global $pkiris;
   global $bin;
   global $raPrivKey;
  
   $errorCode = "a0"; 
   $xmlString = "";
   $retValue = false;
   $initializedXmlFileInfo = false;   
   
   // Tratamos todas las solicitudes con los numeros copa incluidos en el array
   // de entrada '$copasArray'. Si hay algun error paramos
   while ( (list(,$copa) = each ($copasArray)) && $errorCode == "a0" ) {
      $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))"; 
      $justthese = array ("dn","pkirisid","pkirisstatus","pkiristrace");
      $info = ldap_get_info($ldapVar['base'],$filter,$justthese);
      
      if ( !$info ) 
         $errorCode = "a1b3c1";
      else {
	 $status = $info[0]['pkirisstatus'][0];
	 // En '$exportStatus' guardamos el estado al que tendremos que
	 // cambiar la solicitud cuando se haya generado el XML, es decir,
	 // 'ra2ca' (exportada de la RA a la CA)
	 $exportStatus = "ra2ca";
         
         // La exportacion de puede realizar desde nueve estados diferentes. 
	 // Dependiendo si es uno u otro las variables tomaran unos valores u 
	 // otros:
         if ( $status == "approved" ) {
	    // Tendremos que ver si es una 'csr' o una 'rnr'
            $requestType = getRequestTypeFromTraces ($copa);	
	    // En '$traceStatus' vamos a guardar el estado desde el cual vamos
	    // a incluir en el XML las trazas del ldap al que vayamos a 
	    // exportar las solicitudes. Esto se hace para evitar repetir las 
	    // trazas al importar el XML
	    if ( $requestType == "csr" )
	       $traceStatus = "new";
	    else
	       $traceStatus = "renew";
	       
            // En el array 'xmlFileInfo' guardaremos informacion necesaria para
            // generar el fichero XML en la funcion 'createXMLFile' 	    
	    if (!$initializedXmlFileInfo) {
	       $initializedXmlFileInfo = true;
  	       $xmlFileInfo['xmlType'] = "csr";
	       $xmlFileInfo['requestsContainer'] = "csrs";
	       // Obtenemos el numero de RA (entre la 'a' y la 'b' de $copa).
	       // Todas las solicitudes pertenecen a la misma RA
	       list($kk,$tmp)=split("a",$copa);
	       list($num,$kk)=split("b",$tmp);
	       $xmlFileInfo['reqRaNum'] = $num;
	       $initializedXmlFileInfo = true; 
	    }
	 }	
	 else if ( $status == "revoke" ) {
	    $requestType = "crr";
	    $traceStatus = "revoke";
            
	    if (!$initializedXmlFileInfo) {
  	       $xmlFileInfo['xmlType'] = "crr";
	       $xmlFileInfo['requestsContainer'] = "";
	       $initializedXmlFileInfo = true;
	    }
	 }	   
	 else if ( $status == "ra2ca" ) 
	     $errorCode = "a1b3c11";
	 else
            $errorCode = "a1b3c12";
	 
         // Si no ha habido ningun error
         if ( $errorCode == "a0") {
   	    // Guardamos en variables la informacion obtenida del ldap
            $dn = $info[0]['dn']; 
            $pkid = $info[0]['pkirisid'][0];

            // Primero escribimos los tags XML comunes a todos los tipos de 
	    // solicitudes
            $xmlString = $xmlString . "<$requestType>\n";	 
      	    // En $xmlStringSig guardamos la parte del XML de la 
	    // solicitud/certificado a la que le aplicaremos la suma de control
            $xmlStringSig = "<header>\n";   
            $xmlStringSig = $xmlStringSig . "<id>$pkid</id>\n";
            $xmlStringSig = $xmlStringSig . "<copa_id>$copa</copa_id>\n";
            $xmlStringSig = $xmlStringSig . "<dn>$dn</dn>\n";
            $xmlStringSig = $xmlStringSig . "<traces>\n";
           
	    // Obtenemos solo las trazas anyadidas desde el estado $traceStatus
	    $arrayTraces = getTracesFromStatus ($copa, $traceStatus);
	       
	    if ( $arrayTraces == false ) 
	       $errorCode = "a1b3c13";
	    	    
	    $tracesNum = count ($arrayTraces);
            for ($k = 0; $k < $tracesNum; $k++) {
               $trace = $arrayTraces[$k];
	       $xmlStringSig = $xmlStringSig . "<trace>$trace</trace>\n";
	    }	 
            $xmlStringSig = $xmlStringSig . "</traces>\n";
  
            // CSRs
            if ( $requestType == "csr" || $requestType == "rnr" ) {
               // Obtenemos los valores de las etiquetas del ldap
               $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))";
               $justthese = array ("pkiriscerttype","mail","pkirisshowmail","pkirissubjectdn","pkiriscsr");
               $info = ldap_get_info($ldapVar['base'],$filter,$justthese);	 

   	       if ( !$info ) 
	          $errorCode = "a1b3c1";
	       else {
                  $ee_type = $info[0]['pkiriscerttype'][0];
                  $mail = $info[0]['mail'][0];
                  $showmail = $info[0]['pkirisshowmail'][0];
                  $subjectdn = $info[0]['pkirissubjectdn'][0];
   	          $data = $info[0]['pkiriscsr'][0] . "\n";
	   
  	          // Obtenemos el tipo de navegador desde el que se realizo la solicitud
	          $nav_type = getNavType($copa);
	 
                  // Escribimos las etiquetas con sus valores en la cadena
                  $xmlStringSig = $xmlStringSig . "<nav_type>$nav_type</nav_type>\n";
                  $xmlStringSig = $xmlStringSig . "<ee_type>$ee_type</ee_type>\n";
                  $xmlStringSig = $xmlStringSig . "<mail>$mail</mail>\n";
                  $xmlStringSig = $xmlStringSig . "<show_mail>$showmail</show_mail>\n";
                  $xmlStringSig = $xmlStringSig . "<subject_dn>$subjectdn</subject_dn>\n";  
      	       }
            }
            // CRRs
            else {
               // Obtenemos los valores de las etiquetas del ldap
               $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))";
               $justthese = array ("pkirisrevokedbycopaid","pkirisrevocationreason");
               $info = ldap_get_info($ldapVar['base'],$filter,$justthese);

  	       if ( !$info ) 
                  $errorCode = "a1b3c1";
               else {
                  $revokedby = $info[0]['pkirisrevokedbycopaid'][0];
                  $reason = $info[0]['pkirisrevocationreason'][0];
                  $invaliditydate = date("YmdHis"); // En un futuro, esta variable debe tener otro valor
      
		  // Tambien tenemos que obtener el certificado del usuario y 
		  // su numero de serie                                   
		  $userCert = ldap_get_cert($ldapVar['base'],$filter);
		  if (!$userCert)
		     $errorCode = "a1b3c2";
 		  else {
		     $derFile = $dirVar['crt'] . $copa.".x509ee";
                     // Verificamos si existe el fichero y si no lo creamos y 
		     // volcamos la info del certificado en el
                     if (!file_exists($derFile)) {
                        $der = fopen($derFile, "w");
		        fputs($der, $userCert[0]);
		        fclose($der);
		     }
                     // Pasamos el certificado a formato texto
		     $r = exec($bin['openssl'] . " x509 -text -inform DER < " .$derFile, $txtCert);
                     $data = "";		  
 
		     for( $i = 0; $i < count($txtCert); $i++ ) {
                        $data = $data . $txtCert[$i] . "\n";
	                list($tmp, $k) = split(":",trim($txtCert[$i]));
		        if( $tmp == "Serial Number" ){
		           list($k, $tmp) = split("\(",$txtCert[$i]);
		           list($serial, $k)=split("\)",$tmp);
		        }
		     }

		     // Escribimos las etiquetas con sus valores en la cadena
                     $xmlStringSig = $xmlStringSig . "<serial>$serial</serial>\n";
                     $xmlStringSig = $xmlStringSig . "<revoked_by>$revokedby</revoked_by>\n";
                     $xmlStringSig = $xmlStringSig . "<reason>$reason</reason>\n";
                     $xmlStringSig = $xmlStringSig . "<invalidity_date>$invaliditydate</invalidity_date>\n";

		     // Para generar el fichero XML le tenemos que pasar a la
		     // funcion 'createXMLFile' el numero copa y el de serie
		     $xmlFileInfo['copa'] = $copa;
		     $xmlFileInfo['serial'] = $serial;
	          }
               }
            }
            $xmlStringSig = $xmlStringSig . "</header>\n";
            $xmlStringSig = $xmlStringSig . "<data>\n$data</data>\n";

            // Como estamos creando el XML desde una RA, podemos firmar
            // todas las trazas y solicitudes con la misma clave 
            $xmlString = $xmlString . $xmlStringSig . "<sig>".sha1($xmlStringSig.$raPrivKey.$copa)."</sig>\n" . "</$requestType>\n";	 
         }
      }
   }
   
   // Una vez que tenemos el codigo XML de todas las solicitudes, creamos el
   // fichero y volcamos la informacion en el
   if ( $errorCode == "a0" ) {
      $retValue = createXMLFile( $xmlString, $xmlFileInfo );
      if ( !$retValue )
         $errorCode = "a1b3c14";
      // Si se ha generado el fichero correctamente, cambiamos el estado de
      // las solicitudes
      else {
         $r = setExportedStatus ( $copasArray , $exportStatus );
         if ( !$r )
            $errorCode = "a1b3c15";
      }
   }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}

#
# function createXmlFile: recibe una cadena con el codigo XML correspondiente
# a todas las solicitudes de certificado (CSRs/RNRs) o de revocacion (CRRs) y 
# le anyade una cabecera y un pie con informacion sobre la version y el tipo 
# del XML a la cadena de entrada. Por ultimo crea un fichero con ellas. 
# Devuelve la cadena generada o false si ha habido algun error. El fichero 
# se usara para enviar informacion de la RA a la CA.
#
function createXMLFile ( $xmlStringSigned, $xmlFileInfo ) {
   global $pkiris;
   global $dirVar;
   global $raPrivKey;
  
   $errorCode = "a0"; 
   $retValue = false;
   
   $xmlType = $xmlFileInfo['xmlType'];
   $requestsContainer = $xmlFileInfo['requestsContainer'];
    
   $xmlString = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n\n";
   $xmlString = $xmlString . "<pki type=\"$xmlType\" version=\"1.0\">\n";
   
   // $requestsContainer sera vacio cuando estemos creando un fichero con una 
   // CRR, ya que este tipo de XML no necesita ese tipo de tag. Tampoco tienen
   // la firma total del fichero
   if ( $requestsContainer != "") {   
      $xmlStringTotalSig = "<$requestsContainer>\n" . $xmlStringSigned . "</$requestsContainer>\n";
      $xmlString = $xmlString . $xmlStringTotalSig . "<total_sig>".sha1($xmlStringTotalSig . $raPrivKey)."</total_sig>\n";
   }
   else 
      $xmlString = $xmlString . $xmlStringSigned;
     
   // Por ultimo, le anyadimos el tag de cierre de 'pki'
   $xmlString = $xmlString . "</pki>\n";

   // Dependiendo del tipo de XML, el fichero tendra un nombre u otro   
   if ( $requestsContainer == "csrs" ) {
      $reqRaNum = $xmlFileInfo['reqRaNum']; 
      $xmlFile = $dirVar['csr'] . "csr_r".$reqRaNum."d".date('Ymd')."t".date('His').".xml";
   }
   else {
      $copa = $xmlFileInfo['copa'];
      $serial = $xmlFileInfo['serial']; 
      $xmlFile = $dirVar['crr'] . "crr_".$copa."-".$serial.".xml";
   }
   
   // Abrimos el fichero para escribir 
   $fd = fopen ($xmlFile, "w");

   if ( !$fd ) 
      $errorCode = "a1b3c17";
   else {
      // Si no hay errores, escribimos la cadena XML en el fichero
      $r = fwrite ($fd, $xmlString);
      if ( !$r ) 
         $errorCode = "a1b3c18";
      
      $r = fclose ($fd);      
      if ( !$r ) 
	 $errorCode = "a1b3c19";
   }
   // Si no ha habido errores, devolvemos la cadena con el XML
   if ( $errorCode == "a0" )
      $retValue = $xmlString;
     
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}

#
# function exportRaPrivKey: this function exports the Ra private key which copa
# code is '$copa'
#
function exportRaPrivKey($copa, $date) {
      global $ldapVar;
      global $dirVar;

      $errorCode = "a0";
      $retValue = false;
      // Obtenemos la clave privada de la RA
      $privKey = getRaPrivKey ($copa);
	 
      // Construimos el fichero XML con el numero copa y la clave privada
      if ( $privKey != false ) {
         $xmlString = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n\n";
         $xmlString = $xmlString . "<pki type=\"privado\" version=\"1.0\">\n";
         $xmlString = $xmlString . "<privado>\n";
         $xmlString = $xmlString . "<copa_id>$copa</copa_id>\n";
         $xmlString = $xmlString . "<date>$date</date>\n";
         $xmlString = $xmlString . "<private_key>$privKey</private_key>\n";
         // Calculamos la suma de control 'sha1'
         $cadena = "<copa_id>$copa</copa_id>\n" . "<date>$date</date>\n" . "<private_key>$privKey</private_key>\n"; 
	 $xmlString = $xmlString . "<sig>" . sha1($cadena.$privKey.$copa) . "</sig>\n";
	 $xmlString = $xmlString . "</privado>\n";
	 $xmlString = $xmlString . "</pki>";
	 
         // Abrimos el fichero XML para escribir
         $xmlFile = $dirVar['private'] . "private_d".date('Ymd')."t".date('His').".xml"; 
         $fd2 = fopen ($xmlFile, "w");
 
         if ( $fd2 == false ) 
	    echo "\nNo es posible abrir el fichero $xmlFile.";
         else {
            // Si no hay errores, escribimos la cadena XML en el fichero
            $r = fwrite ($fd2, $xmlString);
            if ($r == false)
               echo "\nNo es posible escribir en el fichero $xmlFile.";
            else
	       $retValue = $xmlString;

            fclose ($fd2);
         }
      }
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}

#
# function getRaPrivKey(): devuelve la clave privada de la RA indicada por
# '$copa'. Buscara en el fichero de configuracion de la propia RA.
#
function getRaPrivKey($copa) {
   global $dirVar;
   global $ldapVar;
   
   $errorCode = "a0"; 
   $retValue = false;
   
   // Obtenemos el ldap la url de la RA para poder buscar su fichero
   // de configuracion
   $filter = "(&(objectClass=pkirisAuthority)(pkirisCopaID=$copa))";
   $justthese = array("pkirisRaUrl");
   $result = ldap_get_info($ldapVar['base'], $filter, $justthese);
   if ( !$result )
      $errorCode = "a1b3c1";
   else {
      // Con la url de la RA construimos el nombre del fichero de su
      // configuracion
      $raUrl = $result[0]["pkirisraurl"][0];
      $confFile = $dirVar['conf']."php/".$raUrl.".conf";

      // Comprobamos si existe el fichero de configuracion de la RA
      if ( file_exists($confFile) ) {
         // Abrimos el fichero para leer la clave privada
         $fd = fopen($confFile, "r");
         if ( !$fd ) 
	    $errorCode = "a1b3c17";
         else {
            while ( !feof ($fd) && !$retValue ) {
               $buf = fgets ($fd, 4096);
               if ( strstr($buf, "$"."raPrivKey =") ) {
                  // Le quitamos a la clave privada el nombre de la variable, el
                  // signo '=', las comillas y el ';'
                  list ($k, $tmp) = split ("raPrivKey =", $buf);
                  list ($k2, $tmp2 ) = split ("\"", $tmp);
                  list ($tmp3, $k3 ) = split ("\"", $tmp2);
	          list ($privKey, $k4) = split (";", $tmp3);
	          $retValue = $privKey;
               }
            }														  
         }
      }
      else
         $errorCode = "a1b3c16";
   }

   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}

############################### VARIABLES #####################################

// Home Menu
$menu[0]["/policy/"] = "Pol&iacute;tica de la CA";
$menu[0]["/cacert/"] = "Obtener Certificado de la CA";
$menu[0]["/crt_list.php"] = "Certificados V&aacute;lidos";
$menu[0]["/crl/"] = "Listas de Revocaci&oacute;n";
$menu[0]["/tools/"] = "Descarga de Utilidades";
$menu[0]["/info.php"] = "Informaci&oacute;n de Contacto";
$menu[0]["nohref3"] = "<h3 class='head_a1b1'>Admin</h3>";
$menu[0]["/pki/pkiAdmin/"] = "Administraci&oacute;n de pkIRIS";
$menu[0]["/pki/pkiOper/"] = "Operadores de la CA";

// Public Menu
$menu[1]["nohref1"] = "&nbsp;<b>Solicitar Certificado</b>";
$menu[1]["/$ra_conf/csr_new.php?type=usr"] = "&nbsp;&nbsp;Usuario";
$menu[1]["/$ra_conf/csr_new.php?type=srv"] = "&nbsp;&nbsp;Servidor";
$menu[1]["/$ra_conf/crt_get.php"] = "Descargar Certificado";
$menu[1]["/$ra_conf/crr.php"] = "Revocar Certificado";
$menu[1]["/$ra_conf/crt_renew.php"] = "Renovar Certificado";
$menu[1]["/$ra_conf/admin/"] = "Administraci&oacute;n";
$menu[1]["nohref2"]="<h3 class='head_a1b1'>CA</h3>";
$menu[1]["/policy/"] = "Pol&iacute;tica de la CA";
$menu[1]["/cacert/"] = "Obtener Certificado de la CA";
$menu[1]["/crl/"] = "Listas de Revocaci&oacute;n";
$menu[1]["nohref3"]="<h3 class='head_a1b1'></h3>";
$menu[1]["/$ra_conf/help/sitemap.php"] = "Sitemap";

// RAs Admin Menu 
$menu[2]["csr_manage.php"] = "Gesti&oacute;n de CSRs";
$menu[2]["csr_export.php"] = "Exportar CSRs";
$menu[2]["crr.php"] = "Revocar un Certificado";

// pkiAdmin Menu
$menu[3]["newRa.php"] = "Crear nueva RA";
$menu[3]["delRa.php"] = "Borrar RA";
$menu[3]["raPrivKey_export.php"] = "Exportar clave a la CA";
#$menu[3]["users_manage.php"] = "Gesti&oacute;n de usuarios";

// pkiOper Menu 
$menu[5]["data_import.php"] = "Importar Datos de la CA";
#$menu[5]["manage.php"] = "(por definir)";
#$menu[5]["gen_crl.php"] = "(por definir)";
#$menu[5]["data_export.php"] = "(por definir)";

// All posibles status Array
$aStatus['new']="CSR Nueva";
$aStatus['renew'] = "CSR Renovada";  
$aStatus['approved']="CSR Aprobada";
$aStatus['ra2ca']="CSR Enviada a la CA";
$aStatus['*-denied']="CSR Rechazada por la RA";
$aStatus['*-refused']="CSR Rechazada por la CA";
$aStatus['issued']="Certificados emitidos";
$aStatus['revoke']="Certificados pendientes de revocaci&oacute;n";
$aStatus['revoked-*']="Certificados revocados";

$aAction['download']="Descarga de certificado";
	 
// Year Range for certifacte list form
$def['dFromYYYY']="2005";
$def['dToYYYY']="2016";

###############################################################################
?>
